VERSION 5.00
Begin VB.Form Form2 
   Caption         =   "Merge PJ64 USF Outputs"
   ClientHeight    =   6135
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4215
   LinkTopic       =   "Form2"
   ScaleHeight     =   6135
   ScaleWidth      =   4215
   StartUpPosition =   2  'CenterScreen
   Begin VB.OptionButton optRamRom 
      Caption         =   "ROM"
      Height          =   255
      Index           =   2
      Left            =   3360
      TabIndex        =   8
      Top             =   5760
      Width           =   735
   End
   Begin VB.OptionButton optRamRom 
      Caption         =   "RAM"
      Height          =   255
      Index           =   1
      Left            =   1680
      TabIndex        =   7
      Top             =   5760
      Width           =   855
   End
   Begin VB.OptionButton optRamRom 
      Caption         =   "RAM+ROM"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   6
      Top             =   5760
      Value           =   -1  'True
      Width           =   1215
   End
   Begin VB.CommandButton cmdMerge 
      Caption         =   "Merge .RAMs, .ROMs"
      Height          =   375
      Left            =   1080
      TabIndex        =   5
      Top             =   5280
      Width           =   1935
   End
   Begin VB.TextBox txtOutputName 
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Text            =   "USFOutputBase"
      Top             =   4680
      Width           =   3975
   End
   Begin VB.FileListBox fil1 
      Height          =   1455
      Left            =   120
      Pattern         =   "*.RAM;*.ROM"
      TabIndex        =   2
      Top             =   2880
      Width           =   3975
   End
   Begin VB.DirListBox dir1 
      Height          =   2340
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   3975
   End
   Begin VB.DriveListBox drv1 
      Height          =   315
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3975
   End
   Begin VB.Label lblUSFBase 
      Caption         =   "USF Base (No extension):"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   4440
      Width           =   1935
   End
End
Attribute VB_Name = "Form2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdMerge_Click()

Dim I As Long

Dim NullArray() As Byte

If txtOutputName.Text = vbNullString Then
MsgBox "Must have a USF Base name to use", vbOKOnly, "No USF Base Name"
Exit Sub
End If

cmdMerge.Enabled = False

'Open "D:\emulate\n64\Save\THE LEGEND OF ZELDA.pj8" For Binary As #1
'Debug.Print LOF(1)
'Close #1

'Open "D:\emulate\n64\Legend of Zelda, The - Ocarina of Time (U) (V1.2) [!].z64" For Binary As #1
'Debug.Print LOF(1)
'Close #1

If optRamRom(0).Value Or optRamRom(1).Value Then
Open dir1.Path & "\" & txtOutputName.Text & ".allram" For Output As #1
Close #1

'Open dir1.Path & "\" & txtOutputName.Text & ".allrom" For Binary As #1
''Resize the file to the specified length
'ReDim NullArray(1 To 4204380) As Byte
'Put #1, 1, NullArray
'ReDim NullArray(1 To 1) As Byte
'Close #1

For I = 0 To fil1.ListCount - 1
If LCase$(Right$(fil1.List(I), 4)) = ".ram" Then
Form1.RipBank dir1.Path & "\" & fil1.List(I), 1, False, False, dir1.Path & "\" & txtOutputName.Text & ".allram"
End If
lblUSFBase.Caption = "File " & I & " of " & fil1.ListCount - 1
DoEvents
Next I
End If

If optRamRom(0).Value Or optRamRom(2).Value Then
Open dir1.Path & "\" & txtOutputName.Text & ".allrom" For Output As #1
Close #1

'Open dir1.Path & "\" & txtOutputName.Text & ".allrom" For Binary As #1
''Resize the file to the specified length
'ReDim NullArray(1 To CDbl("&H" & txtOutputFileSize.Text)) As Byte
'Put #1, 1, NullArray
'ReDim NullArray(1 To 1) As Byte
'Close #1

For I = 0 To fil1.ListCount - 1
If LCase$(Right$(fil1.List(I), 4)) = ".rom" Then
Form1.RipBank dir1.Path & "\" & fil1.List(I), 1, False, False, dir1.Path & "\" & txtOutputName.Text & ".allrom"
End If
lblUSFBase.Caption = "File " & I & " of " & fil1.ListCount - 1
DoEvents
Next I
End If

lblUSFBase.Caption = "USF Base (No extension):"
MsgBox "Done", vbOKOnly, "Done"

cmdMerge.Enabled = True


End Sub

Private Sub dir1_Change()

fil1.Path = dir1.Path

End Sub

Private Sub drv1_Change()

dir1.Path = drv1.Drive

End Sub

Public Sub GenerateZelda12FromZelda10()

Dim I As Long
Dim J As Long

Dim TempLong As Long
Dim TempValue As Byte
Dim ByteArray() As Byte

fil1.Path = "D:\mp3play\USF\loz12\Convert\"
fil1.Pattern = "*.miniusf"

For I = 0 To fil1.ListCount - 1

Open "D:\mp3play\USF\loz12\Convert\" & fil1.List(I) For Binary As #1
Open "D:\mp3play\USF\loz12\Convert\Converted\" & fil1.List(I) For Binary As #2
Open "D:\mp3play\USF\loz12\Convert\LOZ_Base.usfstuff" For Binary As #3

'Initialize the file info
ReDim ByteArray(1 To LOF(3))
Get #3, 1, ByteArray
Put #2, 1, ByteArray

'Find song value
For J = 1 To LOF(1) Step 4
'1227388
Get #1, J, TempLong

If TempLong = 1227388 Then
Get #1, J + 5, TempValue
Exit For
End If

Next J

'Put Song Value
Put #2, 33, TempValue

'Put existing tag info into file
Get #1, 5, TempLong
ReDim ByteArray(TempLong + 17 To LOF(1))
Get #1, TempLong + 17, ByteArray
Put #2, LOF(2) + 1, ByteArray

Close #3
Close #2
Close #1

Next I


End Sub

Public Sub GenerateSongValsZelda12FromZelda10()

Dim I As Long
Dim J As Long

Dim TempLong As Long
Dim TempValue As Byte
Dim ByteArray() As Byte

Dim ValuesFound As String

fil1.Path = "D:\mp3play\USF\loz12\Convert\"
fil1.Pattern = "*.miniusf"

For I = 0 To fil1.ListCount - 1

Open "D:\mp3play\USF\loz12\Convert\" & fil1.List(I) For Binary As #1
'Open "D:\mp3play\USF\loz12\Convert\Converted\" & fil1.List(I) For Binary As #2
'Open "D:\mp3play\USF\loz12\Convert\LOZ_Base.usfstuff" For Binary As #3

'Initialize the file info
'ReDim ByteArray(1 To LOF(3))
'Get #3, 1, ByteArray
'Put #2, 1, ByteArray

'Find song value
For J = 1 To LOF(1) Step 4
'1227388
Get #1, J, TempLong

If TempLong = 1227388 Then
Get #1, J + 5, TempValue
ValuesFound = ValuesFound & Right$("00" & Hex$(TempValue), 2) & ","
Exit For
End If

Next J

'Put Song Value
'Put #2, 33, TempValue

'Put existing tag info into file
'Get #1, 5, TempLong
'ReDim ByteArray(TempLong + 17 To LOF(1))
'Get #1, TempLong + 17, ByteArray
'Put #2, LOF(2) + 1, ByteArray

'Close #3
'Close #2
Close #1

Next I

'Clipboard.SetText ValuesFound

End Sub

Public Sub AlterZelda12OldToZelda12New()

Dim I As Long
Dim J As Long

Dim TempLong As Long
Dim TempValue As Byte
Dim ByteArray() As Byte
Dim TempInt As Integer

Dim ValuesFound As String

fil1.Path = "D:\mp3play\USF\loz12\NewConvert\"
fil1.Pattern = "*.miniusf"

For I = 0 To fil1.ListCount - 1

Open "D:\mp3play\USF\loz12\NewConvert\" & fil1.List(I) For Binary As #1
'Open "D:\mp3play\USF\loz12\Convert\Converted\" & fil1.List(I) For Binary As #2
'Open "D:\mp3play\USF\loz12\Convert\LOZ_Base.usfstuff" For Binary As #3

'Initialize the file info
'ReDim ByteArray(1 To LOF(3))
'Get #3, 1, ByteArray
'Put #2, 1, ByteArray

'Find song value
For J = 1 To LOF(1) Step 4
'1227388
Get #1, J, TempLong

If TempLong = 1904 Then
Put #1, J, CLng(768420)

Get #1, J + 6, TempInt

If TempInt <> 9219 Then
MsgBox fil1.List(I), , "Wrong"
Else
TempInt = 9221
Put #1, J + 6, TempInt
End If

'ValuesFound = ValuesFound & Right$("00" & Hex$(TempValue), 2) & ","
Exit For
End If

Next J

'Put Song Value
'Put #2, 33, TempValue

'Put existing tag info into file
'Get #1, 5, TempLong
'ReDim ByteArray(TempLong + 17 To LOF(1))
'Get #1, TempLong + 17, ByteArray
'Put #2, LOF(2) + 1, ByteArray

'Close #3
'Close #2
Close #1

Next I

'Clipboard.SetText ValuesFound

'D:\mp3play\USF\loz12\NewConvert
End Sub

Public Sub AlterZelda12ToZelda10()

Dim I As Long
Dim J As Long

Dim TempLong As Long
Dim TempValue As Byte
Dim ByteArray() As Byte
Dim TempInt As Integer

Dim ValuesFound As String

fil1.Path = "D:\mp3play\USF\loz10\"
fil1.Pattern = "*.miniusf"

For I = 0 To fil1.ListCount - 1

Open "D:\mp3play\USF\loz10\" & fil1.List(I) For Binary As #1

'Find song value
For J = 1 To LOF(1) Step 4

Get #1, J, TempLong

If TempLong = 768420 Then
Put #1, J, CLng(766752)
Exit For
End If

Next J

Close #1

Next I

End Sub


