VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "USFLib Extractor"
   ClientHeight    =   5190
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   5190
   ScaleWidth      =   4680
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdMerge 
      Caption         =   "Merge PJ64 USF Outputs"
      Height          =   495
      Left            =   3000
      TabIndex        =   17
      Top             =   1440
      Width           =   1455
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   495
      Left            =   240
      TabIndex        =   13
      Top             =   3240
      Width           =   1455
   End
   Begin VB.TextBox txtCompressPath 
      Height          =   375
      Left            =   240
      TabIndex        =   12
      Text            =   "C:\!why_d\!!vb\USFTools\USFLib_Extractor\pm.usflib.hex"
      Top             =   4080
      Width           =   4215
   End
   Begin VB.CheckBox chkUseByteflip 
      Caption         =   "Byteflip"
      Height          =   255
      Left            =   3240
      TabIndex        =   11
      Top             =   2880
      Width           =   1215
   End
   Begin VB.CommandButton cmdCompress 
      Caption         =   "Compress"
      Height          =   495
      Left            =   240
      TabIndex        =   10
      Top             =   4560
      Width           =   1455
   End
   Begin VB.TextBox txtOrigin 
      Height          =   375
      Left            =   1920
      TabIndex        =   8
      Text            =   "0"
      Top             =   4680
      Width           =   1575
   End
   Begin VB.TextBox txtBanks 
      Height          =   375
      Left            =   2520
      TabIndex        =   6
      Text            =   "1"
      Top             =   2760
      Width           =   495
   End
   Begin VB.CheckBox chkUseOrigin 
      Caption         =   "Use Origin"
      Height          =   255
      Left            =   3240
      TabIndex        =   5
      Top             =   2640
      Value           =   1  'Checked
      Width           =   1215
   End
   Begin VB.CommandButton cmdExtractCustom 
      Caption         =   "Extract Custom"
      Height          =   495
      Left            =   240
      TabIndex        =   4
      Top             =   2640
      Width           =   1455
   End
   Begin VB.CommandButton cmdImportMiniusf 
      Caption         =   "Import Miniusf"
      Height          =   495
      Left            =   240
      TabIndex        =   3
      Top             =   2040
      Width           =   1455
   End
   Begin VB.TextBox txtMiniusfPath 
      Height          =   375
      Left            =   240
      TabIndex        =   2
      Top             =   840
      Width           =   4215
   End
   Begin VB.TextBox txtFilePath 
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Text            =   "D:\!why_d\!!vb\USFTools\USFLib_Extractor\loz.usflib"
      Top             =   240
      Width           =   4215
   End
   Begin VB.CommandButton cmdExtractSave 
      Caption         =   "Extract Save-State"
      Height          =   495
      Left            =   240
      TabIndex        =   0
      Top             =   1440
      Width           =   1455
   End
   Begin VB.Label Label5 
      Caption         =   "File to compress:"
      Height          =   255
      Left            =   240
      TabIndex        =   16
      Top             =   3840
      Width           =   1215
   End
   Begin VB.Label Label4 
      Caption         =   "Miniusf:"
      Height          =   255
      Left            =   240
      TabIndex        =   15
      Top             =   600
      Width           =   615
   End
   Begin VB.Label Label3 
      Caption         =   "USFLib:"
      Height          =   255
      Left            =   240
      TabIndex        =   14
      Top             =   0
      Width           =   615
   End
   Begin VB.Label Label2 
      Caption         =   "Origin Location(Hex)"
      Height          =   255
      Left            =   1920
      TabIndex        =   9
      Top             =   4440
      Width           =   1575
   End
   Begin VB.Label Label1 
      Caption         =   "SR64 #"
      Height          =   255
      Left            =   1800
      TabIndex        =   7
      Top             =   2760
      Width           =   615
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'Used to narrow down the search area

'Compression
'
'If there's 8 null bytes or less, don't convert.
'4 bytes will become 8, and 8 bytes will be equal in size,
'but more complex to decode.

Dim KeepGoing As Boolean

Const CheckSizeLarge As Long = 10000
Const CheckSizeSmall As Long = 4
Const NullByte As Byte = 0
Const NullLong As Long = 0

Private Type ByteFlip4
Byte1  As Byte
Byte2  As Byte
Byte3  As Byte
Byte4  As Byte
End Type

Private Sub cmdCancel_Click()

KeepGoing = False

End Sub

Private Sub cmdCompress_Click()

'In cases of long overflows, remember that you can probably use
'AND 3FFFFFFF of the origin, and still end up with valid addresses

Dim I As Long
Dim J As Long

Dim ChunkLength As Long
Dim ChunkStart As Long
Dim ChunkStartCount As Long
Dim ChunkOrigin As Long
Dim ChunkGet As Long

Const SR64Tag As Long = 875975251

ChunkOrigin = Val("&H" & txtOrigin.Text)

Open txtCompressPath.Text For Binary As #1
Open txtCompressPath.Text & ".compressed" For Binary As #2

J = 1
Put #2, J, SR64Tag
J = J + 4

I = 1

Do Until I >= LOF(1)
ChunkStart = 0
ChunkLength = 0

'Escape null initial data
For I = I To LOF(1) Step 4
Get #1, I, ChunkGet
If ChunkGet <> 0 Then
Exit For
End If
Next I

'Convert I to 0-init notation for ChunkStart
ChunkStart = I - 1

For I = I To LOF(1) Step 4
Get #1, I, ChunkGet

'Start 0 check
'Noting 4 or 8 null bytes takes at least 8 used bytes to do.
'Not converting unless there's 12 consecutive null bytes works.
If ChunkGet = 0 Then
If I + 4 < LOF(1) Then
Get #1, I + 4, ChunkGet

If ChunkGet = 0 Then
If I + 8 < LOF(1) Then
Get #1, I + 8, ChunkGet

If ChunkGet = 0 Then
Exit For
End If

End If
End If

Else
Exit For
End If
End If
'End Zero Check

'Will only increment if there's not 12 consecutive null bytes
ChunkLength = ChunkLength + 4
Next I

'Add the statistics on the chunk
Put #2, J, ChunkLength
J = J + 4
Put #2, J, ChunkStart + ChunkOrigin
J = J + 4

'Read in the data, based on the gathered chunk data
For ChunkStartCount = (ChunkStart + 1) To (ChunkStart + ChunkLength) Step 4

Get #1, ChunkStartCount, ChunkGet
Put #2, J, ChunkGet
J = J + 4

Next ChunkStartCount

I = ChunkStartCount

Loop

'Add SR64 closing tag
Put #2, J, NullLong

Close

MsgBox "Done", vbOKOnly, "Done"

End Sub

Private Sub cmdImportMiniusf_Click()

Dim I As Long
Dim J As Long
Dim K As Long

Dim CheckGet As String

If txtMiniusfPath.Text = "" Then
Exit Sub
End If

KeepGoing = True

'-----Find the last SR64 tag-----
Open txtMiniusfPath.Text For Binary As #1

CheckGet = Space(CheckSizeLarge)

'Get the final SR64
'Makes it negative, but allows for a 4-byte margin of error
For I = LOF(1) To 1 Step 0 - CheckSizeLarge + 4

Get #1, I, CheckGet

'Exit if within CheckSizeLarge of SR64 string
If InStr(1, CheckGet, "SR64") Then
Exit For
End If

Next I

I = I + CheckSizeLarge

CheckGet = Space(CheckSizeSmall)

'Check each spot individually
For I = I To 1 Step -1

Get #1, I, CheckGet

'Exit if SR64 found
If CheckGet = "SR64" Then
Exit For
End If

Next I

'Quit if it exhausted all available addresses without finding it
If CheckGet <> "SR64" Then
MsgBox "Failed to find SR64 tag", vbOKOnly, "Failed"
Exit Sub
End If

'Get past the SR64 string
I = I + 4
'-----End Find SR64 tag-----

Dim ChunkLength As Long
Dim ChunkLoc As Long
Dim ChunkGet As Byte

'--------------------Do the miniusf file writing-----------

'Add to the Resulting File
Open txtFilePath.Text & ".hex" For Binary As #2

'Reinit
J = 1

Do Until I >= LOF(1)

DoEvents
If KeepGoing = False Then
Close
Exit Sub
End If

'Get the chunk length
Get #1, I, ChunkLength
If ChunkLength = 0 Then
'If the chunklength is 0, it ends the sparse.
Exit Do
End If

I = I + 4 'Go past the Chunk Length

'ChunkGet = Space$(ChunkLength)

'Get the file location
Get #1, I, ChunkLoc
ChunkLoc = ChunkLoc + 1

I = I + 4 'Go past the Chunk Location

'Don't Write nulls to that point. This is just adding/replacing
'If J <> ChunkLoc Then
'For K = J To ChunkLoc
'Put #2, K, NullByte
'Next K
'End If

J = ChunkLoc

'Write data from chunk. -1 is trial and error. Keeps it from reading into next chunk, and adding an extra byte to the end of the file.
For K = 0 To ChunkLength - 1
Get #1, I + K, ChunkGet
Put #2, J + K, ChunkGet
Next K

I = I + ChunkLength
J = J + ChunkLength

Loop
'--------------------End of miniusf file writing-----------

Close

MsgBox "done", vbOKOnly, "done"

End Sub

Private Sub cmdExtractSave_Click()

RipBank txtFilePath.Text, 2, False, False

End Sub

Private Sub cmdExtractCustom_Click()

RipBank txtFilePath.Text, txtBanks.Text, IIf(chkUseOrigin.Value = 1, True, False), IIf(chkUseByteflip.Value = 1, True, False)

End Sub

Private Function GetUSFBanks(FilePath As String) As String

End Function

Public Function RipBank(FilePath As String, SR64Bank As Integer, UseOrigin As Boolean, UseByteflip As Boolean, Optional OverwritingFilePath As String)

Dim I As Long
Dim J As Long
Dim K As Long

Dim CheckGet As String

Dim SR64Count As Integer

Dim ByteFlip1 As ByteFlip4
Dim ByteFlip2 As ByteFlip4

If FilePath = "" Then
Exit Function
End If

KeepGoing = True

'-----Find the first SR64 tag-----
Open FilePath For Binary As #1

CheckGet = Space(CheckSizeLarge)

'Get the SR64 requested
'Allows for no margin of error. It has to be aligned by 4-byte.
For I = 1 To LOF(1) Step CheckSizeLarge

Get #1, I, CheckGet

'Exit if within CheckSizeLarge of SR64 string
If InStr(1, CheckGet, "SR64") Then
SR64Count = SR64Count + 1
If SR64Count = SR64Bank Then
Exit For
End If
End If

Next I

I = I + CheckSizeLarge

CheckGet = Space(CheckSizeSmall)

'Check each spot individually
For I = I To 1 Step -1

Get #1, I, CheckGet

'Exit if SR64 found
If CheckGet = "SR64" Then
Exit For
End If

Next I

'Quit if it exhausted all available addresses without finding it
If CheckGet <> "SR64" Then
MsgBox "Failed to find SR64 tag #" & SR64Bank, vbOKOnly, "Failed"
Exit Function
End If

'Get past the SR64 string
I = I + 4
'-----End Find SR64 tag-----


Dim ChunkLength As Long
Dim ChunkLoc As Long
Dim ChunkGet As Byte
Dim ChunkOrigin As Long
Dim DataArray() As Byte

If OverwritingFilePath = vbNullString Then
Get #1, I, ChunkLength
Get #1, I + 4, ChunkLoc

If MsgBox("The stats for the first chunk in this SR64 bank are:" & vbNewLine & "Chunk Length: " & Right$("00000000" & Hex$(ChunkLength), 8) & IIf((ChunkLength = 32) And (ChunkLoc = 0) And (SR64Bank > 1), " (This is probably the Save-State)", "") & vbNewLine & "Chunk Location: " & Right$("00000000" & Hex(ChunkLoc), 8) & vbNewLine & vbNewLine & "If this looks wrong to you, you can cancel the operation.", vbOKCancel, "Continue / Cancel") = vbCancel Then
Close #1
Exit Function
End If
End If

'--------------------Do the initial file writing-----------

'Build Resulting File
If OverwritingFilePath <> vbNullString Then
Open OverwritingFilePath For Binary As #2
Else
Open FilePath & ".hex" For Binary As #2
End If

'Init
J = 1

Do Until I >= LOF(1)

DoEvents
If KeepGoing = False Then
Close
Exit Function
End If

'Get the chunk length
Get #1, I, ChunkLength
If ChunkLength = 0 Then
'If the chunklength is 0, it ends the sparse.
Exit Do
End If

I = I + 4 'Go past the Chunk Length

'ChunkGet = Space$(ChunkLength)

'Get the file location
Get #1, I, ChunkLoc

'Allow for zero-location for chunks far into the file
If UseOrigin Then
If ChunkOrigin = 0 Then
If ChunkLoc = 0 Then
ChunkOrigin = -1
Else
ChunkOrigin = ChunkLoc
End If
End If

If ChunkOrigin <> -1 Then
ChunkLoc = ChunkLoc - ChunkOrigin
End If
End If

'Needs to be done here, or it's zeroed out
ChunkLoc = ChunkLoc + 1

I = I + 4 'Go past the Chunk Location

If OverwritingFilePath = vbNullString Then
'Write nulls to that point
If J <> ChunkLoc Then
'This could use a ReDim Array safely
'Redim should clear out the array
'ReDim DataArray(1 To 1) As Byte
ReDim DataArray(J To ChunkLoc) As Byte
Put #2, J, DataArray

'For K = J To ChunkLoc
'Put #2, K, NullByte
'Next K
End If

Else
'Pad the end of the file to the desired write location

If ChunkLoc > LOF(2) Then
ReDim DataArray(LOF(2) To ChunkLoc) As Byte
Put #2, LOF(2) + 1, DataArray
End If

End If

J = ChunkLoc

If UseByteflip Then
For K = 0 To ChunkLength - 1 Step 4
Get #1, I + K, ByteFlip1

ByteFlip2.Byte1 = ByteFlip1.Byte4
ByteFlip2.Byte2 = ByteFlip1.Byte3
ByteFlip2.Byte3 = ByteFlip1.Byte2
ByteFlip2.Byte4 = ByteFlip1.Byte1

Put #2, J + K, ByteFlip2
Next K
Else
'Write data from chunk. -1 is trial and error. Keeps it from reading into next chunk, and adding an extra byte to the end of the file.

'Replaced with ReDim
'For K = 0 To ChunkLength - 1
'Get #1, I + K, ChunkGet
'Put #2, J + K, ChunkGet
'Next K

ReDim DataArray(1 To ChunkLength) As Byte
Get #1, I, DataArray
Put #2, J, DataArray

'ReDim DataArray(1 To 2) As Byte

End If

I = I + ChunkLength
J = J + ChunkLength

Loop

'--------------------End of initial file writing-----------

'Should do save-state-size expansion from here

Close

If OverwritingFilePath = vbNullString Then
If ChunkOrigin > 0 Then
MsgBox "done" & vbNewLine & "Chunk Origin:" & vbNewLine & Right$("00000000" & Hex$(ChunkOrigin), 8), vbOKOnly, "done"
Else
MsgBox "done", vbOKOnly, "done"
End If
End If
End Function

Private Sub cmdMerge_Click()

Form2.Show vbModal

End Sub

Private Sub txtBanks_LostFocus()

If Val(txtBanks.Text) <= 0 Then
txtBanks.Text = 1
End If

End Sub
